#!/bin/bash

file_age() {
	_int_file_age=$(( $(date +"%s") - $(stat -c "%Y" "$1") ))

	echo "$_int_file_age"
}

get_cache_file() {
	echo "$CACHEDIR/$1.$2"
}

get_cached_file() {
	_int_file=$(get_cache_file "$1" "$2")

	if [ -f "$_int_file" ]; then
		_int_age=$(file_age "$_int_file")

		if [ "$_int_age" -gt "$CACHEMAXAGE" ]; then
			echo ""
		else
			_int_data=$(cat "$_int_file")

			echo "$_int_data"

			varname="CACHED_$2"

			#export ${varname}="$_int_data"
		fi
	else
		echo ""
	fi
}

update_cached_file() {
	_int_file=$(get_cache_file "$1" "$2")

	_int_data=$3

	if ! echo "$_int_data" | tee "$_int_file" > /dev/null; then
		return 1
	else
		return 0
	fi
}

get_cached_url_data() {
	_int_file_data=$(get_cached_file "$1" "$2")

	if [ -z "$_int_file_data" ]; then
		echo ""
	else
		_int_url_data=$(curl -A "$UA" -s "$_int_file_data" 2>/dev/null)

		echo "$_int_url_data"
	fi
}
