#!/bin/bash

s_echo()
{
	echo "[$(date)] $@" >> "$LOGFILE"
}

request()
{
	curl -A "$UA" -s --cookie-jar "$COOKIEFILE" -b "$COOKIEFILE" $@
}

get_status_code()
{
	request -A "$UA" -I -X GET "$1" | head -n1 | awk -F" " '{print $2}'
}

_int_get_playlist_url()
{
	_int_chan=$1

	s_echo "Get playlist for: $_int_chan"

	#_int_chanurl="https://$DOMAIN/mediateka/tiesiogiai/$_int_chan"
	_int_chanurl="https://$DOMAIN/servisai/stream_url/live/get_live_url.php?channel=$_int_chan"

	_int_data=$(request "$_int_chanurl")

	_int_url=$(grep -i "playlist" <<< "$_int_data" | awk -F\" '{for(i=1;i<NF;i++){if($i~/^https/){print $i}}}' | sed -e 's#\\/#/#g')

	echo "$_int_url"

	return 0
}

_int_get_chunklist_url() {
	_int_chan=$1

	_int_playlist=$(get_playlist "$_int_chan")

	if [ -z "$_int_playlist" ]; then
		return 1
	fi

	# first chunklist should have the highest bitrate
	_int_chunklist_fn=$(grep "chunklist" <<< "$_int_playlist" | head -n 1)

	if [ -z "$_int_chunklist_fn" ]; then
		s_echo "Got playlist without any chunklists for $_int_chan !"

		return 1
	fi

	_int_url=$(get_cached_file "$_int_chan" "playlist")
	_int_source_url=$(dirname "$_int_url")

	_int_chunklist_url="$_int_source_url/$_int_chunklist_fn"

	echo "$_int_chunklist_url"

	return 0
}

_int_get_template() {
	_int_chan=$1
	_int_type=$2
	_int_callback=$3
	_int_data=$(get_cached_url_data "$_int_chan" "$_int_type")

	if [ -z "$_int_data" ]; then
		s_echo "Updating cached $_int_type for $_int_chan"

		_int_url=$($_int_callback "$_int_chan")

		# order is important for $? !
		if [ $? -ne 0 ] || [ -z "$_int_url" ]; then
			s_echo "Failed to retrieve $_int_type for $_int_chan !"

			return 1
		fi

		if ! update_cached_file "$_int_chan" "$_int_type" "$_int_url"; then
			s_echo "Failed to update cached $_int_type for $_int_chan !"

			return 1
		fi

		_int_data=$(get_cached_url_data "$_int_chan" "$_int_type")

		if [ -z "$_int_data" ]; then
			s_echo "Failed to get $_int_type for $_int_chan"
		fi
	#else
	#	s_echo "Cache hit: $_int_type for $_int_chan"
	fi

	echo "$_int_data"
}

get_chunklist() {
	_int_chunklist=$(_int_get_template "$1" "chunklist" "_int_get_chunklist_url")

	# there has to be a better way to do this...
	_int_playlist_url=$(get_cached_file "$1" "playlist")
	_int_source_url=$(dirname "$_int_playlist_url")

	sed -e "s#media#$_int_source_url/media#g" <<< "$_int_chunklist"
}

get_playlist() {
	_int_get_template "$1" "playlist" "_int_get_playlist_url"
}
